//////////////////////////////////////////////////////////////////////////////
///   Copyright 2003 and onward LASMEA UMR 6602 CNRS/U.B.P Clermont-Ferrand
///   Copyright 2009 and onward LRI    UMR 8623 CNRS/Univ Paris Sud XI
///
///          Distributed under the Boost Software License, Version 1.0
///                 See accompanying file LICENSE.txt or copy at
///                     http://www.boost.org/LICENSE_1_0.txt
//////////////////////////////////////////////////////////////////////////////
#ifndef BOOST_SIMD_TOOLBOX_ARITHMETIC_ARITHMETIC_HPP_INCLUDED
#define BOOST_SIMD_TOOLBOX_ARITHMETIC_ARITHMETIC_HPP_INCLUDED

//<include> please don't modify between these tags
#include <boost/simd/toolbox/arithmetic/include/functions/fast_toint.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/negs.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/divround.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/divfloor.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/divfix.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/divceil.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/random.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/logical_xor.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/ifloor.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/fast_hypot.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/iround.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/arg.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/sqrt1pm1.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/remainder.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/rem.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/mod.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/remquo.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/minmod.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/iceil.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/trunc.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/ceil.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/round.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/floor.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/two_split.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/two_prod.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/two_add.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/rsqrt.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/sqrt.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/sqr.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/rec.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/rdivide.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/oneplus.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/oneminus.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/minusone.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/min.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/max.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/madd.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/ldivide.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/ldiv.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/idivround.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/idivfloor.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/idivfix.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/idivceil.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/hypot.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/fma.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/fam.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/dist.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/correct_fma.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/average.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/amul.hpp>
#include <boost/simd/toolbox/arithmetic/include/functions/abs.hpp>
//<\include>

#endif
